diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/model/ipv6-l3-protocol.cc ns-3.42/src/internet/model/ipv6-l3-protocol.cc
--- ns-3.41/src/internet/model/ipv6-l3-protocol.cc	2024-02-09 14:44:07.933790200 -0800
+++ ns-3.42/src/internet/model/ipv6-l3-protocol.cc	2024-05-29 15:29:46.964073200 -0700
@@ -191,7 +191,6 @@
 Ptr<Ipv6RoutingProtocol>
 Ipv6L3Protocol::GetRoutingProtocol() const
 {
-    NS_LOG_FUNCTION(this);
     return m_routingProtocol;
 }
 
@@ -235,8 +234,6 @@
 Ptr<Ipv6Interface>
 Ipv6L3Protocol::GetInterface(uint32_t index) const
 {
-    NS_LOG_FUNCTION(this << index);
-
     if (index < m_interfaces.size())
     {
         return m_interfaces[index];
@@ -247,14 +244,12 @@
 uint32_t
 Ipv6L3Protocol::GetNInterfaces() const
 {
-    NS_LOG_FUNCTION(this);
     return m_nInterfaces;
 }
 
 int32_t
 Ipv6L3Protocol::GetInterfaceForAddress(Ipv6Address address) const
 {
-    NS_LOG_FUNCTION(this << address);
     int32_t index = 0;
 
     for (auto it = m_interfaces.begin(); it != m_interfaces.end(); it++)
@@ -277,7 +272,6 @@
 int32_t
 Ipv6L3Protocol::GetInterfaceForPrefix(Ipv6Address address, Ipv6Prefix mask) const
 {
-    NS_LOG_FUNCTION(this << address << mask);
     int32_t index = 0;
 
     for (auto it = m_interfaces.begin(); it != m_interfaces.end(); it++)
@@ -299,15 +293,12 @@
 Ptr<NetDevice>
 Ipv6L3Protocol::GetNetDevice(uint32_t i)
 {
-    NS_LOG_FUNCTION(this << i);
     return GetInterface(i)->GetDevice();
 }
 
 int32_t
 Ipv6L3Protocol::GetInterfaceForDevice(Ptr<const NetDevice> device) const
 {
-    NS_LOG_FUNCTION(this << device);
-
     auto iter = m_reverseInterfacesContainer.find(device);
     if (iter != m_reverseInterfacesContainer.end())
     {
@@ -459,7 +450,6 @@
 uint32_t
 Ipv6L3Protocol::GetNAddresses(uint32_t i) const
 {
-    NS_LOG_FUNCTION(this << i);
     Ptr<Ipv6Interface> interface = GetInterface(i);
     return interface->GetNAddresses();
 }
@@ -467,7 +457,6 @@
 Ipv6InterfaceAddress
 Ipv6L3Protocol::GetAddress(uint32_t i, uint32_t addressIndex) const
 {
-    NS_LOG_FUNCTION(this << i << addressIndex);
     Ptr<Ipv6Interface> interface = GetInterface(i);
     return interface->GetAddress(addressIndex);
 }
@@ -524,7 +513,6 @@
 uint16_t
 Ipv6L3Protocol::GetMetric(uint32_t i) const
 {
-    NS_LOG_FUNCTION(this << i);
     Ptr<Ipv6Interface> interface = GetInterface(i);
     return interface->GetMetric();
 }
@@ -532,8 +520,6 @@
 uint16_t
 Ipv6L3Protocol::GetMtu(uint32_t i) const
 {
-    NS_LOG_FUNCTION(this << i);
-
     // RFC 1981, if PMTU is disabled, return the minimum MTU
     if (!m_mtuDiscover)
     {
@@ -554,7 +540,6 @@
 bool
 Ipv6L3Protocol::IsUp(uint32_t i) const
 {
-    NS_LOG_FUNCTION(this << i);
     Ptr<Ipv6Interface> interface = GetInterface(i);
     return interface->IsUp();
 }
@@ -645,7 +630,6 @@
 bool
 Ipv6L3Protocol::IsForwarding(uint32_t i) const
 {
-    NS_LOG_FUNCTION(this << i);
     Ptr<Ipv6Interface> interface = GetInterface(i);
 
     NS_LOG_LOGIC("Forwarding state: " << interface->IsForwarding());
@@ -722,7 +706,6 @@
 bool
 Ipv6L3Protocol::GetIpForward() const
 {
-    NS_LOG_FUNCTION(this);
     return m_ipForward;
 }
 
@@ -736,7 +719,6 @@
 bool
 Ipv6L3Protocol::GetMtuDiscover() const
 {
-    NS_LOG_FUNCTION(this);
     return m_mtuDiscover;
 }
 
@@ -750,7 +732,6 @@
 bool
 Ipv6L3Protocol::GetSendIcmpv6Redirect() const
 {
-    NS_LOG_FUNCTION(this);
     return m_sendIcmpv6Redirect;
 }
 
@@ -848,16 +829,12 @@
 Ptr<IpL4Protocol>
 Ipv6L3Protocol::GetProtocol(int protocolNumber) const
 {
-    NS_LOG_FUNCTION(this << protocolNumber);
-
     return GetProtocol(protocolNumber, -1);
 }
 
 Ptr<IpL4Protocol>
 Ipv6L3Protocol::GetProtocol(int protocolNumber, int32_t interfaceIndex) const
 {
-    NS_LOG_FUNCTION(this << protocolNumber << interfaceIndex);
-
     if (interfaceIndex >= 0)
     {
         // try the interface-specific protocol.
@@ -907,7 +884,6 @@
 Ptr<Icmpv6L4Protocol>
 Ipv6L3Protocol::GetIcmpv6() const
 {
-    NS_LOG_FUNCTION(this);
     Ptr<IpL4Protocol> protocol = GetProtocol(Icmpv6L4Protocol::GetStaticProtocolNumber());
 
     if (protocol)
@@ -1126,12 +1102,8 @@
         }
     }
 
-    if (hdr.GetDestination().IsAllNodesMulticast())
-    {
-        LocalDeliver(packet, hdr, interface);
-        return;
-    }
-    else if (hdr.GetDestination().IsAllRoutersMulticast() && ipv6Interface->IsForwarding())
+    if (hdr.GetDestination().IsAllNodesMulticast() ||
+        (hdr.GetDestination().IsAllRoutersMulticast() && ipv6Interface->IsForwarding()))
     {
         LocalDeliver(packet, hdr, interface);
         return;
@@ -1562,32 +1534,37 @@
                 p->RemoveAtStart(nextHeaderPosition);
                 /* protocol->Receive (p, src, dst, incomingInterface); */
 
+                // Options have been processed, and the packet is good.
+                // We need to adjust the IP header fields
+                Ipv6Header newIpHeader = ip;
+                newIpHeader.SetNextHeader(nextHeader);
+                newIpHeader.SetPayloadLength(p->GetSize());
+
                 /* L4 protocol */
                 Ptr<Packet> copy = p->Copy();
 
-                m_localDeliverTrace(ip, p, iif);
+                m_localDeliverTrace(newIpHeader, p, iif);
 
-                IpL4Protocol::RxStatus status = protocol->Receive(p, ip, GetInterface(iif));
+                IpL4Protocol::RxStatus status =
+                    protocol->Receive(p, newIpHeader, GetInterface(iif));
 
                 switch (status)
                 {
                 case IpL4Protocol::RX_OK:
-                    break;
                 case IpL4Protocol::RX_CSUM_FAILED:
-                    break;
                 case IpL4Protocol::RX_ENDPOINT_CLOSED:
                     break;
                 case IpL4Protocol::RX_ENDPOINT_UNREACH:
-                    if (ip.GetDestination().IsMulticast())
+                    if (newIpHeader.GetDestination().IsMulticast())
                     {
                         /* do not rely on multicast address */
                         break;
                     }
 
-                    copy->AddHeader(ip);
+                    copy->AddHeader(newIpHeader);
                     GetIcmpv6()->SendErrorDestinationUnreachable(
                         copy,
-                        ip.GetSource(),
+                        newIpHeader.GetSource(),
                         Icmpv6Header::ICMPV6_PORT_UNREACHABLE);
                 }
             }
@@ -1768,8 +1745,6 @@
 bool
 Ipv6L3Protocol::IsRegisteredMulticastAddress(Ipv6Address address, uint32_t interface) const
 {
-    NS_LOG_FUNCTION(address << interface);
-
     Ipv6RegisteredMulticastAddressKey_t key = std::make_pair(address, interface);
     auto iter = m_multicastAddresses.find(key);
 
@@ -1779,8 +1754,6 @@
 bool
 Ipv6L3Protocol::IsRegisteredMulticastAddress(Ipv6Address address) const
 {
-    NS_LOG_FUNCTION(address);
-
     auto iter = m_multicastAddressesNoInterface.find(address);
 
     return iter != m_multicastAddressesNoInterface.end();
@@ -1845,7 +1818,6 @@
 bool
 Ipv6L3Protocol::GetStrongEndSystemModel() const
 {
-    NS_LOG_FUNCTION(this);
     return m_strongEndSystemModel;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/model/ipv6-option-header.cc ns-3.42/src/internet/model/ipv6-option-header.cc
--- ns-3.41/src/internet/model/ipv6-option-header.cc	2024-02-09 14:44:07.933790200 -0800
+++ ns-3.42/src/internet/model/ipv6-option-header.cc	2024-05-29 15:29:46.964073200 -0700
@@ -124,7 +124,7 @@
 Ipv6OptionHeader::Alignment
 Ipv6OptionHeader::GetAlignment() const
 {
-    return (Alignment){1, 0};
+    return Alignment{1, 0};
 }
 
 NS_OBJECT_ENSURE_REGISTERED(Ipv6OptionPad1Header);
@@ -329,7 +329,7 @@
 Ipv6OptionHeader::Alignment
 Ipv6OptionJumbogramHeader::GetAlignment() const
 {
-    return (Alignment){4, 2}; // 4n+2
+    return Alignment{4, 2}; // 4n+2
 }
 
 NS_OBJECT_ENSURE_REGISTERED(Ipv6OptionRouterAlertHeader);
@@ -411,7 +411,7 @@
 Ipv6OptionHeader::Alignment
 Ipv6OptionRouterAlertHeader::GetAlignment() const
 {
-    return (Alignment){2, 0}; // 2n+0
+    return Alignment{2, 0}; // 2n+0
 }
 
 } /* namespace ns3 */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/model/ipv6-static-routing.cc ns-3.42/src/internet/model/ipv6-static-routing.cc
--- ns-3.41/src/internet/model/ipv6-static-routing.cc	2024-02-09 14:44:07.933790200 -0800
+++ ns-3.42/src/internet/model/ipv6-static-routing.cc	2024-05-29 15:29:46.964073200 -0700
@@ -444,22 +444,18 @@
                 uint32_t interfaceIdx = route->GetInterface();
                 rtentry = Create<Ipv6Route>();
 
-                if (route->GetGateway().IsAny())
+                if (route->GetGateway().IsAny() || !route->GetDest().IsAny())
                 {
                     rtentry->SetSource(
                         m_ipv6->SourceAddressSelection(interfaceIdx, route->GetDest()));
                 }
-                else if (route->GetDest().IsAny()) /* default route */
+                else
                 {
+                    // Default route
                     rtentry->SetSource(m_ipv6->SourceAddressSelection(
                         interfaceIdx,
                         route->GetPrefixToUse().IsAny() ? dst : route->GetPrefixToUse()));
                 }
-                else
-                {
-                    rtentry->SetSource(
-                        m_ipv6->SourceAddressSelection(interfaceIdx, route->GetDest()));
-                }
 
                 rtentry->SetDestination(route->GetDest());
                 rtentry->SetGateway(route->GetGateway());
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/model/loopback-net-device.cc ns-3.42/src/internet/model/loopback-net-device.cc
--- ns-3.41/src/internet/model/loopback-net-device.cc	2024-02-09 14:44:07.933790200 -0800
+++ ns-3.42/src/internet/model/loopback-net-device.cc	2024-05-29 15:29:46.964073200 -0700
@@ -58,11 +58,7 @@
 {
     NS_LOG_FUNCTION(packet << " " << protocol << " " << to << " " << from);
     NetDevice::PacketType packetType;
-    if (to == m_address)
-    {
-        packetType = NetDevice::PACKET_HOST;
-    }
-    else if (to.IsBroadcast())
+    if (to == m_address || to.IsBroadcast())
     {
         packetType = NetDevice::PACKET_HOST;
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/model/rip.cc ns-3.42/src/internet/model/rip.cc
--- ns-3.41/src/internet/model/rip.cc	2024-02-09 14:44:07.937790400 -0800
+++ ns-3.42/src/internet/model/rip.cc	2024-05-29 15:29:46.964073200 -0700
@@ -741,7 +741,7 @@
             route->SetRouteStatus(RipRoutingTableEntry::RIP_INVALID);
             route->SetRouteMetric(m_linkDown);
             route->SetRouteChanged(true);
-            if (it->second.IsRunning())
+            if (it->second.IsPending())
             {
                 it->second.Cancel();
             }
@@ -1241,11 +1241,8 @@
                         rte.SetRouteMetric(rtIter->first->GetRouteMetric());
                     }
                     rte.SetRouteTag(rtIter->first->GetRouteTag());
-                    if (m_splitHorizonStrategy == SPLIT_HORIZON && !splitHorizoning)
-                    {
-                        hdr.AddRte(rte);
-                    }
-                    else if (m_splitHorizonStrategy != SPLIT_HORIZON)
+                    if ((m_splitHorizonStrategy == SPLIT_HORIZON && !splitHorizoning) ||
+                        (m_splitHorizonStrategy != SPLIT_HORIZON))
                     {
                         hdr.AddRte(rte);
                     }
@@ -1278,7 +1275,7 @@
 {
     NS_LOG_FUNCTION(this);
 
-    if (m_nextTriggeredUpdate.IsRunning())
+    if (m_nextTriggeredUpdate.IsPending())
     {
         NS_LOG_LOGIC("Skipping Triggered Update due to cooldown");
         return;
@@ -1310,7 +1307,7 @@
 {
     NS_LOG_FUNCTION(this);
 
-    if (m_nextTriggeredUpdate.IsRunning())
+    if (m_nextTriggeredUpdate.IsPending())
     {
         m_nextTriggeredUpdate.Cancel();
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/model/ripng.cc ns-3.42/src/internet/model/ripng.cc
--- ns-3.41/src/internet/model/ripng.cc	2024-02-09 14:44:07.937790400 -0800
+++ ns-3.42/src/internet/model/ripng.cc	2024-05-29 15:29:46.964073200 -0700
@@ -740,7 +740,7 @@
             route->SetRouteStatus(RipNgRoutingTableEntry::RIPNG_INVALID);
             route->SetRouteMetric(m_linkDown);
             route->SetRouteChanged(true);
-            if (it->second.IsRunning())
+            if (it->second.IsPending())
             {
                 it->second.Cancel();
             }
@@ -1242,11 +1242,8 @@
                         rte.SetRouteMetric(rtIter->first->GetRouteMetric());
                     }
                     rte.SetRouteTag(rtIter->first->GetRouteTag());
-                    if (m_splitHorizonStrategy == SPLIT_HORIZON && !splitHorizoning)
-                    {
-                        hdr.AddRte(rte);
-                    }
-                    else if (m_splitHorizonStrategy != SPLIT_HORIZON)
+                    if ((m_splitHorizonStrategy == SPLIT_HORIZON && !splitHorizoning) ||
+                        (m_splitHorizonStrategy != SPLIT_HORIZON))
                     {
                         hdr.AddRte(rte);
                     }
@@ -1279,7 +1276,7 @@
 {
     NS_LOG_FUNCTION(this);
 
-    if (m_nextTriggeredUpdate.IsRunning())
+    if (m_nextTriggeredUpdate.IsPending())
     {
         NS_LOG_LOGIC("Skipping Triggered Update due to cooldown");
         return;
@@ -1311,7 +1308,7 @@
 {
     NS_LOG_FUNCTION(this);
 
-    if (m_nextTriggeredUpdate.IsRunning())
+    if (m_nextTriggeredUpdate.IsPending())
     {
         m_nextTriggeredUpdate.Cancel();
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/model/tcp-bbr.cc ns-3.42/src/internet/model/tcp-bbr.cc
--- ns-3.41/src/internet/model/tcp-bbr.cc	2024-02-09 14:44:07.937790400 -0800
+++ ns-3.42/src/internet/model/tcp-bbr.cc	2024-05-29 15:29:46.964073200 -0700
@@ -58,7 +58,7 @@
             .AddAttribute("RttWindowLength",
                           "Length of RTT windowed filter",
                           TimeValue(Seconds(10)),
-                          MakeTimeAccessor(&TcpBbr::m_rtPropFilterLen),
+                          MakeTimeAccessor(&TcpBbr::m_minRttFilterLen),
                           MakeTimeChecker())
             .AddAttribute("ProbeRttDuration",
                           "Time to be spent in PROBE_RTT phase",
@@ -107,18 +107,17 @@
       m_targetCWnd(sock.m_targetCWnd),
       m_fullBandwidth(sock.m_fullBandwidth),
       m_fullBandwidthCount(sock.m_fullBandwidthCount),
-      m_rtProp(Time::Max()),
+      m_minRtt(Time::Max()),
       m_sendQuantum(sock.m_sendQuantum),
       m_cycleStamp(sock.m_cycleStamp),
       m_cycleIndex(sock.m_cycleIndex),
-      m_rtPropExpired(sock.m_rtPropExpired),
-      m_rtPropFilterLen(sock.m_rtPropFilterLen),
-      m_rtPropStamp(sock.m_rtPropStamp),
+      m_minRttExpired(sock.m_minRttExpired),
+      m_minRttFilterLen(sock.m_minRttFilterLen),
+      m_minRttStamp(sock.m_minRttStamp),
       m_isInitialized(sock.m_isInitialized),
       m_uv(sock.m_uv),
       m_delivered(sock.m_delivered),
       m_appLimited(sock.m_appLimited),
-      m_txItemDelivered(sock.m_txItemDelivered),
       m_extraAckedGain(sock.m_extraAckedGain),
       m_extraAckedWinRtt(sock.m_extraAckedWinRtt),
       m_extraAckedWinRttLength(sock.m_extraAckedWinRttLength),
@@ -220,6 +219,7 @@
 {
     NS_LOG_FUNCTION(this << tcb << gain);
     DataRate rate(gain * m_maxBwFilter.GetBest().GetBitRate());
+    rate *= (1.f - m_pacingMargin);
     rate = std::min(rate, tcb->m_maxPacingRate);
 
     if (!m_hasSeenRtt && tcb->m_minRtt != Time::Max())
@@ -237,12 +237,12 @@
 TcpBbr::InFlight(Ptr<TcpSocketState> tcb, double gain)
 {
     NS_LOG_FUNCTION(this << tcb << gain);
-    if (m_rtProp == Time::Max())
+    if (m_minRtt == Time::Max())
     {
         return tcb->m_initialCWnd * tcb->m_segmentSize;
     }
     double quanta = 3 * m_sendQuantum;
-    double estimatedBdp = m_maxBwFilter.GetBest() * m_rtProp / 8.0;
+    double estimatedBdp = m_maxBwFilter.GetBest() * m_minRtt / 8.0;
 
     if (m_state == BbrMode_t::BBR_PROBE_BW && m_cycleIndex == 0)
     {
@@ -264,7 +264,7 @@
 TcpBbr::IsNextCyclePhase(Ptr<TcpSocketState> tcb, const TcpRateOps::TcpRateSample& rs)
 {
     NS_LOG_FUNCTION(this << tcb << rs);
-    bool isFullLength = (Simulator::Now() - m_cycleStamp) > m_rtProp;
+    bool isFullLength = (Simulator::Now() - m_cycleStamp) > m_minRtt;
     if (m_pacingGain == 1)
     {
         return isFullLength;
@@ -355,11 +355,11 @@
 TcpBbr::UpdateRTprop(Ptr<TcpSocketState> tcb)
 {
     NS_LOG_FUNCTION(this << tcb);
-    m_rtPropExpired = Simulator::Now() > (m_rtPropStamp + m_rtPropFilterLen);
-    if (tcb->m_lastRtt >= Seconds(0) && (tcb->m_lastRtt <= m_rtProp || m_rtPropExpired))
+    m_minRttExpired = Simulator::Now() > (m_minRttStamp + m_minRttFilterLen);
+    if (tcb->m_lastRtt >= Seconds(0) && (tcb->m_lastRtt <= m_minRtt || m_minRttExpired))
     {
-        m_rtProp = tcb->m_lastRtt;
-        m_rtPropStamp = Simulator::Now();
+        m_minRtt = tcb->m_lastRtt;
+        m_minRttStamp = Simulator::Now();
     }
 }
 
@@ -429,7 +429,7 @@
         }
         if (m_probeRttRoundDone && Simulator::Now() > m_probeRttDoneStamp)
         {
-            m_rtPropStamp = Simulator::Now();
+            m_minRttStamp = Simulator::Now();
             RestoreCwnd(tcb);
             ExitProbeRTT();
         }
@@ -440,7 +440,7 @@
 TcpBbr::CheckProbeRTT(Ptr<TcpSocketState> tcb, const TcpRateOps::TcpRateSample& rs)
 {
     NS_LOG_FUNCTION(this << tcb);
-    if (m_state != BbrMode_t::BBR_PROBE_RTT && m_rtPropExpired && !m_idleRestart)
+    if (m_state != BbrMode_t::BBR_PROBE_RTT && m_minRttExpired && !m_idleRestart)
     {
         EnterProbeRTT();
         SaveCwnd(tcb);
@@ -611,11 +611,11 @@
 }
 
 void
-TcpBbr::UpdateBtlBw(Ptr<TcpSocketState> tcb, const TcpRateOps::TcpRateSample& rs)
+TcpBbr::UpdateBottleneckBandwidth(Ptr<TcpSocketState> tcb, const TcpRateOps::TcpRateSample& rs)
 {
     NS_LOG_FUNCTION(this << tcb << rs);
 
-    if (rs.m_deliveryRate == 0)
+    if (rs.m_delivered < 0 || rs.m_interval.IsZero())
     {
         return;
     }
@@ -632,7 +632,7 @@
 TcpBbr::UpdateModelAndState(Ptr<TcpSocketState> tcb, const TcpRateOps::TcpRateSample& rs)
 {
     NS_LOG_FUNCTION(this << tcb << rs);
-    UpdateBtlBw(tcb, rs);
+    UpdateBottleneckBandwidth(tcb, rs);
     UpdateAckAggregation(tcb, rs);
     CheckCyclePhase(tcb, rs);
     CheckFullPipe(rs);
@@ -700,7 +700,6 @@
 {
     NS_LOG_FUNCTION(this << tcb << rs);
     m_delivered = rc.m_delivered;
-    m_txItemDelivered = rc.m_txItemDelivered;
     UpdateModelAndState(tcb, rs);
     UpdateControlParameters(tcb, rs);
 }
@@ -712,8 +711,8 @@
     if (newState == TcpSocketState::CA_OPEN && !m_isInitialized)
     {
         NS_LOG_DEBUG("CongestionStateSet triggered to CA_OPEN :: " << newState);
-        m_rtProp = tcb->m_lastRtt.Get() != Time::Max() ? tcb->m_lastRtt.Get() : Time::Max();
-        m_rtPropStamp = Simulator::Now();
+        m_minRtt = tcb->m_lastRtt.Get() != Time::Max() ? tcb->m_lastRtt.Get() : Time::Max();
+        m_minRttStamp = Simulator::Now();
         m_priorCwnd = tcb->m_cWnd;
         tcb->m_ssThresh = tcb->m_initialSsThresh;
         m_targetCWnd = tcb->m_cWnd;
@@ -772,7 +771,7 @@
         {
             if (m_probeRttRoundDone && Simulator::Now() > m_probeRttDoneStamp)
             {
-                m_rtPropStamp = Simulator::Now();
+                m_minRttStamp = Simulator::Now();
                 RestoreCwnd(tcb);
                 ExitProbeRTT();
             }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/model/tcp-bbr.h ns-3.42/src/internet/model/tcp-bbr.h
--- ns-3.41/src/internet/model/tcp-bbr.h	2024-02-09 14:44:07.937790400 -0800
+++ ns-3.42/src/internet/model/tcp-bbr.h	2024-05-29 15:29:46.964073200 -0700
@@ -293,7 +293,7 @@
      * \param tcb the socket state.
      * \param rs rate sample.
      */
-    void UpdateBtlBw(Ptr<TcpSocketState> tcb, const TcpRateOps::TcpRateSample& rs);
+    void UpdateBottleneckBandwidth(Ptr<TcpSocketState> tcb, const TcpRateOps::TcpRateSample& rs);
 
     /**
      * \brief Updates control parameters congestion windowm, pacing rate, send quantum.
@@ -373,25 +373,23 @@
     uint32_t m_targetCWnd{0}; //!< Target value for congestion window, adapted to the estimated BDP
     DataRate m_fullBandwidth{0};      //!< Value of full bandwidth recorded
     uint32_t m_fullBandwidthCount{0}; //!< Count of full bandwidth recorded consistently
-    Time m_rtProp{
+    Time m_minRtt{
         Time::Max()}; //!< Estimated two-way round-trip propagation delay of the path, estimated
                       //!< from the windowed minimum recent round-trip delay sample.
     uint32_t m_sendQuantum{
         0}; //!< The maximum size of a data aggregate scheduled and transmitted together
     Time m_cycleStamp{Seconds(0)};       //!< Last time gain cycle updated
     uint32_t m_cycleIndex{0};            //!< Current index of gain cycle
-    bool m_rtPropExpired{false};         //!< A boolean recording whether the BBR.RTprop has expired
-    Time m_rtPropFilterLen{Seconds(10)}; //!< A constant specifying the length of the RTProp min
+    bool m_minRttExpired{false};         //!< A boolean recording whether the BBR.RTprop has expired
+    Time m_minRttFilterLen{Seconds(10)}; //!< A constant specifying the length of the RTProp min
                                          //!< filter window, default 10 secs.
-    Time m_rtPropStamp{
+    Time m_minRttStamp{
         Seconds(0)}; //!< The wall clock time at which the current BBR.RTProp sample was obtained
-    bool m_isInitialized{false}; //!< Set to true after first time initializtion variables
+    bool m_isInitialized{false}; //!< Set to true after first time initialization variables
     Ptr<UniformRandomVariable> m_uv{nullptr}; //!< Uniform Random Variable
     uint64_t m_delivered{0}; //!< The total amount of data in bytes delivered so far
     uint32_t m_appLimited{
         0}; //!< The index of the last transmitted packet marked as application-limited
-    uint32_t m_txItemDelivered{
-        0}; //!< The number of bytes already delivered at the time of new packet transmission
     uint32_t m_extraAckedGain{1};         //!< Gain factor for adding extra ack to cwnd
     uint32_t m_extraAcked[2]{0, 0};       //!< Maximum excess data acked in epoch
     uint32_t m_extraAckedWinRtt{0};       //!< Age of extra acked in rtt
@@ -402,6 +400,8 @@
     Time m_ackEpochTime{Seconds(0)}; //!< Starting of ACK sampling epoch time
     uint32_t m_ackEpochAcked{0};     //!< Bytes ACked in sampling epoch
     bool m_hasSeenRtt{false};        //!< Have we seen RTT sample yet?
+    double m_pacingMargin{0.01}; //!< BBR intentionally reduces the pacing rate by 1% to drain any
+                                 //!< standing queues. See `bbr_rate_bytes_per_sec` in Linux.
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/model/tcp-cubic.cc ns-3.42/src/internet/model/tcp-cubic.cc
--- ns-3.41/src/internet/model/tcp-cubic.cc	2024-02-09 14:44:07.937790400 -0800
+++ ns-3.42/src/internet/model/tcp-cubic.cc	2024-05-29 15:29:46.964073200 -0700
@@ -189,6 +189,13 @@
 {
     NS_LOG_FUNCTION(this << tcb << segmentsAcked);
 
+    if (!tcb->m_isCwndLimited)
+    {
+        NS_LOG_DEBUG("No increase because current cwnd " << tcb->m_cWnd
+                                                         << " is not limiting the flow");
+        return;
+    }
+
     if (tcb->m_cWnd < tcb->m_ssThresh)
     {
         if (m_hystart && tcb->m_lastAckedSeq > m_endSeq)
@@ -490,7 +497,6 @@
 {
     NS_LOG_FUNCTION(this << tcb);
 
-    m_lastMaxCwnd = 0;
     m_bicOriginPoint = 0;
     m_bicK = 0;
     m_ackCnt = 0;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/model/tcp-dctcp.cc ns-3.42/src/internet/model/tcp-dctcp.cc
--- ns-3.41/src/internet/model/tcp-dctcp.cc	2024-02-09 14:44:07.937790400 -0800
+++ ns-3.42/src/internet/model/tcp-dctcp.cc	2024-05-29 15:29:46.964073200 -0700
@@ -121,6 +121,7 @@
     tcb->m_useEcn = TcpSocketState::On;
     tcb->m_ecnMode = TcpSocketState::DctcpEcn;
     tcb->m_ectCodePoint = m_useEct0 ? TcpSocketState::Ect0 : TcpSocketState::Ect1;
+    SetSuppressIncreaseIfCwndLimited(false);
     m_initialized = true;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/model/tcp-highspeed.cc ns-3.42/src/internet/model/tcp-highspeed.cc
--- ns-3.41/src/internet/model/tcp-highspeed.cc	2024-02-09 14:44:07.937790400 -0800
+++ ns-3.42/src/internet/model/tcp-highspeed.cc	2024-05-29 15:29:46.964073200 -0700
@@ -447,15 +447,14 @@
     {
         return 73;
     }
-    else
-    {
-        return 73;
-    }
+
+    return 73;
 }
 
 double
 TcpHighSpeed::TableLookupB(uint32_t w)
 {
+    // NOLINTBEGIN(bugprone-branch-clone)
     if (w <= 38)
     {
         return 0.50;
@@ -752,6 +751,7 @@
     {
         return 0.09;
     }
+    // NOLINTEND(bugprone-branch-clone)
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/model/tcp-linux-reno.cc ns-3.42/src/internet/model/tcp-linux-reno.cc
--- ns-3.41/src/internet/model/tcp-linux-reno.cc	2024-02-09 14:44:07.937790400 -0800
+++ ns-3.42/src/internet/model/tcp-linux-reno.cc	2024-05-29 15:29:46.968073100 -0700
@@ -79,6 +79,13 @@
 {
     NS_LOG_FUNCTION(this << tcb << segmentsAcked);
 
+    if (m_suppressIncreaseIfCwndLimited && !tcb->m_isCwndLimited)
+    {
+        NS_LOG_DEBUG("No increase because current cwnd " << tcb->m_cWnd
+                                                         << " is not limiting the flow");
+        return;
+    }
+
     uint32_t w = tcb->m_cWnd / tcb->m_segmentSize;
 
     // Floor w to 1 if w == 0
@@ -150,4 +157,11 @@
     return CopyObject<TcpLinuxReno>(this);
 }
 
+void
+TcpLinuxReno::SetSuppressIncreaseIfCwndLimited(bool value)
+{
+    NS_LOG_FUNCTION(this << value);
+    m_suppressIncreaseIfCwndLimited = value;
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/model/tcp-linux-reno.h ns-3.42/src/internet/model/tcp-linux-reno.h
--- ns-3.41/src/internet/model/tcp-linux-reno.h	2024-02-09 14:44:07.937790400 -0800
+++ ns-3.42/src/internet/model/tcp-linux-reno.h	2024-05-29 15:29:46.968073100 -0700
@@ -76,8 +76,25 @@
      */
     virtual void CongestionAvoidance(Ptr<TcpSocketState> tcb, uint32_t segmentsAcked);
 
+    /**
+     * TcpSocketBase follows the Linux way of setting a flag 'isCwndLimited'
+     * when BytesInFlight() >= cwnd.  This flag, if true, will suppress
+     * additive increase window updates for this class.  However, some
+     * derived classes using the IncreaseWindow() method may not want this
+     * behavior, so this method exists to allow subclasses to set it to false.
+     *
+     * \param value Value to set whether the isCwndLimited condition
+     *        suppresses window updates
+     */
+    void SetSuppressIncreaseIfCwndLimited(bool value);
+
   private:
     uint32_t m_cWndCnt{0}; //!< Linear increase counter
+    // The below flag exists for classes derived from TcpLinuxReno (such as
+    // TcpDctcp) that may not want to suppress cwnd increase, unlike Linux's
+    // tcp_reno_cong_avoid()
+    bool m_suppressIncreaseIfCwndLimited{
+        true}; //!< Suppress window increase if TCP is not cwnd limited
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/model/tcp-rate-ops.cc ns-3.42/src/internet/model/tcp-rate-ops.cc
--- ns-3.41/src/internet/model/tcp-rate-ops.cc	2024-02-09 14:44:07.941790300 -0800
+++ ns-3.42/src/internet/model/tcp-rate-ops.cc	2024-05-29 15:29:46.968073100 -0700
@@ -106,7 +106,7 @@
 
     /* Normally we expect m_interval >= minRtt.
      * Note that rate may still be over-estimated when a spuriously
-     * retransmistted skb was first (s)acked because "interval_us"
+     * retransmitted skb was first (s)acked because "interval_us"
      * is under-estimated (up to an RTT). However continuously
      * measuring the delivery rate during loss recovery is crucial
      * for connections suffer heavy or prolonged losses.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/model/tcp-recovery-ops.h ns-3.42/src/internet/model/tcp-recovery-ops.h
--- ns-3.41/src/internet/model/tcp-recovery-ops.h	2024-02-09 14:44:07.941790300 -0800
+++ ns-3.42/src/internet/model/tcp-recovery-ops.h	2024-05-29 15:29:46.968073100 -0700
@@ -95,7 +95,7 @@
      * The function is called when the TcpSocketState is changed to CA_RECOVERY.
      *
      * \param tcb internal congestion state
-     * \param dupAckCount duplicate acknowldgement count
+     * \param dupAckCount duplicate acknowledgement count
      * \param unAckDataCount total bytes of data unacknowledged
      * \param deliveredBytes bytes (S)ACKed in the last (S)ACK
      */
